// TTTGroup.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "TeazersTimeTracker.h"
#include "TTTGroup.h"


// TTTGroup

TTTGroup::TTTGroup()
{
	this->m_parent=NULL;
	this->m_description="neue Gruppe";
	this->m_notes="Kann Auftraggeber darstellen, Projekte, oder auch einfach nur beliebige andere logische Gruppierungen...";
	m_treeitem=NULL;
}

TTTGroup::~TTTGroup()
{
	while (childtimers.GetCount()>0) delete childtimers.GetHead();
	while (childtodos.GetCount()>0) delete childtodos.GetHead();
	while (childgroups.GetCount()>0) delete childgroups.GetHead();

	if (m_parent) m_parent->childgroups.RemoveAt((m_parent->childgroups.Find(this)));
}


// TTTGroup-Memberfunktionen

IMPLEMENT_SERIAL (TTTGroup,CObject,42);

void TTTGroup::Serialize( CArchive& archive ) 
{
    // call base class function first
    // base class is CObject in this case
    CObject::Serialize( archive );

    // now do the stuff for our specific class
    if( archive.IsStoring() ) 
	{
        archive << m_description << m_notes;

		int numGroups,numTodos,numTimers=0;

		numTodos=childtodos.GetSize();
		numTimers=childtimers.GetSize();
		numGroups=childgroups.GetSize();

		archive << numTodos << numTimers << numGroups;

		for (int i=0;i<numTodos;i++) 
		{
			TTTTodo* nextTodo=childtodos.GetAt(childtodos.FindIndex(i));
			ASSERT(nextTodo);
			archive << nextTodo;
		};

		for (int i=0;i<numTimers;i++) 
		{
			TTTTimer* nextTimer=childtimers.GetAt(childtimers.FindIndex(i));
			ASSERT(nextTimer);
			archive << nextTimer;
		};

		for (int i=0;i<numGroups;i++) 
		{
			TTTGroup* nextGroup=childgroups.GetAt(childgroups.FindIndex(i));
			ASSERT(nextGroup);
			archive << nextGroup;
		};

	} else {
        archive >> m_description >> m_notes;

		int numGroups,numTodos,numTimers=0;

		archive >> numTodos >> numTimers >> numGroups;

		for (int i=0;i<numTodos;i++) 
		{
			TTTTodo* newTodo=NULL; 
			archive >> newTodo;
			newTodo->m_parent=this;
			newTodo->m_treeitem=NULL;
		};

		for (int i=0;i<numTimers;i++) 
		{
			TTTTimer* newTimer=NULL; 
			archive >> newTimer;
			newTimer->m_parent=this;
			newTimer->m_treeitem=NULL;
		};

		for (int i=0;i<numGroups;i++) 
		{
			TTTGroup* newGroup=NULL; 
			archive >> newGroup;
			newGroup->m_parent=this;
			newGroup->m_treeitem=NULL;
		};
	};
};

bool TTTGroup::operator==(const TTTGroup &other) {

	if ((void*)this!=(void*)&other) return false;
	else return true;

}

void TTTGroup::addTimer(CString &desc)
{
	TTTTimer* newTimer = new TTTTimer(this);
	newTimer->m_description = desc;

	childtimers.AddTail(newTimer);
}

void TTTGroup::addTodo(CString &desc)
{
	TTTTodo* newTodo = new TTTTodo(this);
	newTodo->m_description = desc;

	childtodos.AddTail(newTodo);
}

void TTTGroup::addGroup(CString &desc)
{
	TTTGroup* newGroup = new TTTGroup();
	newGroup->m_description=desc;
	newGroup->m_parent=this;
	childgroups.AddTail(newGroup);
}

TTTGroup::TTTGroup( const TTTGroup &s )  // copy ctor
{ //m_nValue = s.m_nValue; 

}

TTTGroup& TTTGroup::operator=( const TTTGroup &s )  // assignment operator
{ //m_nValue = s.m_nValue; 
	return *this; 
}


