// TTTTimer.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "TeazersTimeTracker.h"
#include "TTTTimer.h"
#include "TTTGroup.h"

// TTTTimer

TTTTimer::TTTTimer()
{
	m_starttime = COleDateTime::GetCurrentTime();
	m_stoptime = COleDateTime::GetCurrentTime();
	m_isRunning = TRUE;
	m_description = "neuer Timer"; 
	m_notes = "Beschreibt einen einzelnen Arbeitszeitabschnitt."; 
	m_parent=NULL;
	m_treeitem=NULL;
	m_pausenzeit=0;

}

TTTTimer::TTTTimer(TTTGroup* p)
{
	m_starttime = COleDateTime::GetCurrentTime();
	m_stoptime = COleDateTime::GetCurrentTime();
	m_isRunning = TRUE;
	m_description = "neuer Timer"; 
	m_notes = "Beschreibt einen einzelnen Arbeitszeitabschnitt."; 
	m_parent=p;
	m_treeitem=NULL;
	m_pausenzeit=0;
}

TTTTimer::~TTTTimer()
{
	if (m_parent) m_parent->childtimers.RemoveAt((m_parent->childtimers.Find(this)));
}


// TTTTimer-Memberfunktionen


bool TTTTimer::operator==(const TTTTimer other) {

	if ((void*)this!=(void*)&other) return false;
	else return true;

}

IMPLEMENT_SERIAL (TTTTimer, CObject, 42);

void TTTTimer::Serialize( CArchive& archive ) 
{
    // call base class function first
    // base class is CObject in this case
    CObject::Serialize( archive );

    // now do the stuff for our specific class
    if( archive.IsStoring() )
	{
		archive << m_starttime << m_stoptime << m_isRunning << m_description << m_notes << m_pausenzeit;
	}
    else
	{
		archive >> m_starttime >> m_stoptime >> m_isRunning >> m_description >> m_notes >> m_pausenzeit;
	};

	m_parent=NULL;
	m_treeitem=NULL;
};

TTTTimer::TTTTimer( const TTTTimer &s )  // copy ctor
{ //m_nValue = s.m_nValue;

	m_starttime=s.m_starttime;
	m_stoptime=s.m_stoptime;
	m_isRunning=s.m_isRunning;
	m_description=s.m_description;
	m_parent=s.m_parent;
	m_notes=s.m_notes;
	m_pausenzeit=s.m_pausenzeit;
	m_treeitem=NULL;
}

TTTTimer& TTTTimer::operator=( const TTTTimer &s )  // assignment operator
{ //m_nValue = s.m_nValue; 
	return *this; 
}

CString TTTTimer::getLengthStr()
{
	COleDateTimeSpan ts=getLength();
	CString running = _T(" (luft noch)");
	CString zeit;
	zeit.Format(_T("%02d:%02d:%02d gearbeitet."), ((ts.GetDays()*24)+ts.GetHours()),ts.GetMinutes(),ts.GetSeconds());

	if (m_isRunning) return (zeit+running);
	else return zeit;
}


double TTTTimer::getLengthInSeconds() 
{
	return getLength().GetTotalSeconds();
};

COleDateTimeSpan TTTTimer::getLength()
{
	COleDateTimeSpan subTs;
	COleDateTimeSpan ts;
	subTs.SetDateTimeSpan(0,0,m_pausenzeit,0);
	if (!m_isRunning) ts=(m_stoptime-m_starttime)-subTs;
	else ts=COleDateTime::GetCurrentTime()-m_starttime;
	return ts;
};

void TTTTimer::stop() 
{
	m_isRunning=FALSE;
	m_stoptime=COleDateTime::GetCurrentTime();
};
