// TabTimer.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "TeazersTimeTracker.h"
#include "TeazersTimeTrackerDlg.h"
#include "TabTimer.h"
#include "afxdialogex.h"


// CTabTimer-Dialogfeld

IMPLEMENT_DYNAMIC(CTabTimer, CDialogEx)

CTabTimer::CTabTimer(CWnd* pParent /*=NULL*/)
	: CDialogEx(CTabTimer::IDD, pParent)
	, m_pzint(0)
{
}

CTabTimer::~CTabTimer()
{
}

void CTabTimer::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT1, m_description);
	DDX_Control(pDX, IDC_EDIT2, m_notes);
	DDX_Control(pDX, IDC_ST_LENGTH, m_length);
	DDX_Control(pDX, IDC_EDIT3, m_pausenzeit);
}

BEGIN_MESSAGE_MAP(CTabTimer, CDialogEx)
END_MESSAGE_MAP()

// CTabTimer-Meldungshandler

void CTabTimer::OnOK( ) {};
void CTabTimer::OnCancel( ) {};

void CTabTimer::setStartDateTime(COleDateTime& timeDest) 
{
	CDateTimeCtrl* pTime = (CDateTimeCtrl*) GetDlgItem(IDC_DTP_START_TIME);
	CDateTimeCtrl* pDate = (CDateTimeCtrl*) GetDlgItem(IDC_DTP_START_DATE);
	ASSERT(pTime != NULL);
	ASSERT(pDate != NULL);

	pTime->SetTime(timeDest);
	pDate->SetTime(timeDest);
};

void CTabTimer::setEndDateTime(COleDateTime& timeDest) 
{
	CDateTimeCtrl* pTime = (CDateTimeCtrl*) GetDlgItem(IDC_DTP_END_TIME);
	CDateTimeCtrl* pDate = (CDateTimeCtrl*) GetDlgItem(IDC_DTP_END_DATE);
	ASSERT(pTime != NULL);
	ASSERT(pDate != NULL);

	pTime->SetTime(timeDest);
	pDate->SetTime(timeDest);
};

void CTabTimer::getStartDateTime(COleDateTime& timeDest) 
{
	CDateTimeCtrl* pTime = (CDateTimeCtrl*) GetDlgItem(IDC_DTP_START_TIME);
	CDateTimeCtrl* pDate = (CDateTimeCtrl*) GetDlgItem(IDC_DTP_START_DATE);
	ASSERT(pTime != NULL);
	ASSERT(pDate != NULL);

	COleDateTime timeTime;
	COleDateTime timeDate;

	pTime->GetTime(timeTime);
	pDate->GetTime(timeDate);

	timeDest.SetDateTime(timeDate.GetYear(),timeDate.GetMonth(),timeDate.GetDay(),timeTime.GetHour(),timeTime.GetMinute(),timeTime.GetSecond());
};
void CTabTimer::setEndDisabled(BOOL state)
{
	CDateTimeCtrl* pTime = (CDateTimeCtrl*) GetDlgItem(IDC_DTP_END_TIME);
	CDateTimeCtrl* pDate = (CDateTimeCtrl*) GetDlgItem(IDC_DTP_END_DATE);
	ASSERT(pTime != NULL);
	ASSERT(pDate != NULL);

	pTime->EnableWindow(!state);
	pDate->EnableWindow(!state);
}

void CTabTimer::getEndDateTime(COleDateTime& timeDest) 
{
	CDateTimeCtrl* pTime = (CDateTimeCtrl*) GetDlgItem(IDC_DTP_END_TIME);
	CDateTimeCtrl* pDate = (CDateTimeCtrl*) GetDlgItem(IDC_DTP_END_DATE);
	ASSERT(pTime != NULL);
	ASSERT(pDate != NULL);

	COleDateTime timeTime;
	COleDateTime timeDate;

	pTime->GetTime(timeTime);
	pDate->GetTime(timeDate);

	timeDest.SetDateTime(timeDate.GetYear(),timeDate.GetMonth(),timeDate.GetDay(),timeTime.GetHour(),timeTime.GetMinute(),timeTime.GetSecond());
};


