
// TeazersTimeTrackerDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "TeazersTimeTracker.h"
#include "TeazersTimeTrackerDlg.h"
#include "afxdialogex.h"
#include "textentrydlg.h"
#include <iostream>
#include "TTTExportDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialogfelddaten
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung

// Implementierung
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CTeazersTimeTrackerDlg-Dialogfeld




CTeazersTimeTrackerDlg::CTeazersTimeTrackerDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CTeazersTimeTrackerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTeazersTimeTrackerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TAB2, m_tabview);
	DDX_Control(pDX, IDC_B_STOP, m_btn_stop);
	DDX_Control(pDX, IDC_B_GSTOP, m_btn_gstop);
	DDX_Control(pDX, IDC_B_ASTOP, m_btn_astop);
	DDX_Control(pDX, IDC_BTN_DELNODE, m_btn_removenode);
	DDX_Control(pDX, IDC_BTN_EXPNODE, m_btn_expnode);
}

BEGIN_MESSAGE_MAP(CTeazersTimeTrackerDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE1, &CTeazersTimeTrackerDlg::OnTvnSelchangedTree1)
	ON_BN_CLICKED(IDC_BUTTON1, &CTeazersTimeTrackerDlg::OnBnClickedAddTimer)
	ON_BN_CLICKED(IDC_BUTTON2, &CTeazersTimeTrackerDlg::OnBnClickedAddGroup)
	ON_BN_CLICKED(IDC_BUTTON3, &CTeazersTimeTrackerDlg::OnCancel)
	ON_BN_CLICKED(IDC_BUTTON4, &CTeazersTimeTrackerDlg::OnBnClickedAddTodo)
	ON_BN_CLICKED(IDC_BTNAPPLY, &CTeazersTimeTrackerDlg::OnBnClickedApply)
	ON_BN_CLICKED(IDC_B_STOP, &CTeazersTimeTrackerDlg::OnBnClickedBStop)
	ON_BN_CLICKED(IDC_B_GSTOP, &CTeazersTimeTrackerDlg::OnBnClickedBGstop)
	ON_BN_CLICKED(IDC_B_ASTOP, &CTeazersTimeTrackerDlg::OnBnClickedBAstop)
	ON_BN_CLICKED(IDC_BTN_DELNODE, &CTeazersTimeTrackerDlg::OnBnClickedBtnDelnode)
	ON_BN_CLICKED(IDC_BTN_EXPNODE, &CTeazersTimeTrackerDlg::OnBnClickedBtnExport)
	ON_BN_CLICKED(IDC_BTN_EXPNODE2, &CTeazersTimeTrackerDlg::OnBnClickedBtnExpnode2)
END_MESSAGE_MAP()


// CTeazersTimeTrackerDlg-Meldungshandler

BOOL CTeazersTimeTrackerDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	rootNode.m_description="Statische Wurzelgruppe";
	rootNode.m_notes="Diese Gruppe dient nur als Ursprung aller anderen Gruppen, Timer und ToDo Items und ist in keinem Masse interessant oder editierbar fr den Benutzer.";

	HINSTANCE hInstance = GetModuleHandle(NULL);

	HICON groupIcon = LoadIcon(hInstance,MAKEINTRESOURCE(IDI_Group));
	HICON timerIcon = LoadIcon(hInstance,MAKEINTRESOURCE(IDI_TIMER));
	HICON timer_run_Icon = LoadIcon(hInstance,MAKEINTRESOURCE(IDI_TIMER_RUN));
	HICON todo_done_Icon = LoadIcon(hInstance,MAKEINTRESOURCE(IDI_TODO_DONE));
	HICON todo_open_Icon = LoadIcon(hInstance,MAKEINTRESOURCE(IDI_TODO_OPEN));
	// Create the full-color image list
	// cx, cy = your icon width & height
	// You could also use ILC_COLOR24 rather than ILC_COLOR32

	iList.Create(16, 16, ILC_MASK | ILC_COLOR32, 0, 0);

	// Add the bitmap into the image list
	iList.Add(groupIcon);
	iList.Add(timerIcon);
	iList.Add(todo_open_Icon);
	iList.Add(timer_run_Icon);
	iList.Add(todo_done_Icon);

	CTreeCtrl* pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE1);
	ASSERT(pTree != NULL);

	pTree->SetImageList(&iList,TVSIL_NORMAL);

	TVINSERTSTRUCT tvInsert;
	tvInsert.hParent = NULL;
	tvInsert.hInsertAfter = NULL;
	tvInsert.item.mask = TVIF_TEXT;
	tvInsert.item.state = TVIS_EXPANDED;
	tvInsert.item.stateMask = TVIS_EXPANDED;
	tvInsert.item.pszText = _T("*");

	rootNode.m_treeitem = pTree->InsertItem(&tvInsert);
	pTree->Expand(rootNode.m_treeitem,TVE_EXPAND);

	m_tabview.InsertItem(0, _T("Group"));
	m_tabview.InsertItem(1, _T("Timer"));
	m_tabview.InsertItem(2, _T("ToDo"));

	m_tabview.Init();

	m_tabview.m_tabtimer->m_parentTTT=this;
	m_tabview.m_tabgroup->m_parentTTT=this;
	m_tabview.m_tabtodo->m_parentTTT=this;

	loadTree();

	return TRUE;  // TRUE zurckgeben, wenn der Fokus nicht auf ein Steuerelement gesetzt wird
}

void CTeazersTimeTrackerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// Wenn Sie dem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch ausgefhrt.

void CTeazersTimeTrackerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR CTeazersTimeTrackerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTeazersTimeTrackerDlg::OnTvnSelchangedTree1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);

	CTreeCtrl* pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE1);
	ASSERT(pTree != NULL);

	HTREEITEM sel=pTree->GetSelectedItem();
	ASSERT(sel != NULL);

	Type retType=getTypeByTreeId(sel,&rootNode,pTree);

	TTTTimer* momTimer=NULL;
	TTTTodo* momTodo=NULL;
	TTTGroup* momGroup=NULL;
	CString pause;

	switch (retType) 
	{
	case TIMER:
			momTimer=getTimerByTreeId(sel,&rootNode,pTree);
			m_tabview.SetCurSel(1);
			m_tabview.m_tabtimer->m_description.SetWindowText(momTimer->m_description);
			m_tabview.m_tabtimer->m_notes.SetWindowText(momTimer->m_notes);
			m_tabview.m_tabtimer->setStartDateTime(momTimer->m_starttime);
			m_tabview.m_tabtimer->m_length.SetWindowText(momTimer->getLengthStr());
			pause.Format(_T("%d"),momTimer->m_pausenzeit);
			m_tabview.m_tabtimer->m_pausenzeit.SetWindowText(pause);
			if (momTimer->m_isRunning) 
			{
				m_tabview.m_tabtimer->setEndDisabled(TRUE);
				m_tabview.m_tabtimer->setEndDateTime(COleDateTime::GetCurrentTime());
			}
			else 
			{
				m_tabview.m_tabtimer->setEndDateTime(momTimer->m_stoptime);
				m_tabview.m_tabtimer->setEndDisabled(FALSE);
			}
			m_btn_stop.EnableWindow(TRUE);
			m_btn_gstop.EnableWindow(FALSE);
			m_btn_removenode.EnableWindow(TRUE);
			m_btn_expnode.EnableWindow(TRUE);
			break;
	case TODO:
			momTodo=getTodoByTreeId(sel,&rootNode,pTree);
			m_tabview.SetCurSel(2);
			m_tabview.m_tabtodo->m_description.SetWindowText(momTodo->m_description);
			if (momTodo->m_isCompleted) m_tabview.m_tabtodo->m_checked.SetCheck(BST_CHECKED);
			else m_tabview.m_tabtodo->m_checked.SetCheck(BST_UNCHECKED);
			m_tabview.m_tabtodo->m_notes.SetWindowText(momTodo->m_notes);
			m_btn_stop.EnableWindow(FALSE);
			m_btn_gstop.EnableWindow(FALSE);
			m_btn_removenode.EnableWindow(TRUE);
			m_btn_expnode.EnableWindow(FALSE);
			break;
	case GROUP:
			momGroup=getParentGroupByTreeId(sel,&rootNode,pTree);
			m_tabview.SetCurSel(0);
			m_tabview.m_tabgroup->m_description.SetReadOnly(false);
			m_tabview.m_tabgroup->m_notes.SetReadOnly(false);
			m_tabview.m_tabgroup->m_description.SetWindowText(momGroup->m_description);
			m_tabview.m_tabgroup->m_notes.SetWindowText(momGroup->m_notes);
			m_btn_stop.EnableWindow(FALSE);
			m_btn_gstop.EnableWindow(TRUE);
			m_btn_removenode.EnableWindow(TRUE);
			m_btn_expnode.EnableWindow(TRUE);
			break;
	case ROOT:
			momGroup=getParentGroupByTreeId(sel,&rootNode,pTree);
			m_tabview.SetCurSel(0);
			m_tabview.m_tabgroup->m_description.SetWindowText(momGroup->m_description);
			m_tabview.m_tabgroup->m_notes.SetWindowText(momGroup->m_notes);
			m_tabview.m_tabgroup->m_description.SetReadOnly(true);
			m_tabview.m_tabgroup->m_notes.SetReadOnly(true);
			m_btn_stop.EnableWindow(FALSE);
			m_btn_gstop.EnableWindow(FALSE);
			m_btn_removenode.EnableWindow(FALSE);
			m_btn_expnode.EnableWindow(TRUE);
			break;
	};

	*pResult = 0;
	updateTree();
	pTree->SetItem(sel,TVIF_STATE,NULL,0,0,TVIS_BOLD,TVIS_BOLD,0);
}

void CTeazersTimeTrackerDlg::OnBnClickedAddTimer()
{
	CTreeCtrl* pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE1);
	ASSERT(pTree != NULL);

	HTREEITEM sel=pTree->GetSelectedItem();
	ASSERT(sel != NULL);

	//suche ermittelte selection per HTREEITEM Id im Gruppenbaum
	TTTGroup* tgtGroup=getParentGroupByTreeId(sel,&rootNode,pTree);

	CString desc;

	CTextEntryDlg dlgTextEntry;
	dlgTextEntry.Show(this, _T("Timername?"), _T("Bitte Timername festlegen"), _T("Neuer Timer"));
	desc = dlgTextEntry.GetText();

	// fge neue Gruppe als Unterpunkt der ermittelten Gruppe hinzu
	tgtGroup->addTimer(desc);

	updateTree();

	pTree->SetItem(sel,TVIF_STATE,NULL,0,0,TVIS_BOLD,TVIS_BOLD,0);
	pTree->SelectItem(sel);
	 
}

void CTeazersTimeTrackerDlg::updateTree()
{
	// Gain a pointer to our tree control

	CTreeCtrl* pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE1);
	ASSERT(pTree != NULL);

	drawGroup(&rootNode,pTree);

	pTree->SortChildren(rootNode.m_treeitem);

}

void CTeazersTimeTrackerDlg::drawGroup(TTTGroup* g, CTreeCtrl* pTree)
{
	//iterate child groups and add TreeItems. Wow, ich hasse Graphentheorie. :P Tiefensuche...

	for (int i=0;i<g->childgroups.GetCount();i++)
	{
		TTTGroup* nextGroup=g->childgroups.GetAt(g->childgroups.FindIndex(i));
		if (nextGroup->m_treeitem==NULL) nextGroup->m_treeitem = pTree->InsertItem(nextGroup->m_description,0,0,nextGroup->m_parent->m_treeitem,TVI_SORT);
		else {
			pTree->SetItem(nextGroup->m_treeitem, TVIF_STATE|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_TEXT, nextGroup->m_description,0,0,0,TVIS_BOLD,NULL);
		};
		pTree->Expand(g->m_treeitem, TVE_EXPAND);
		drawGroup(nextGroup,pTree);
	};

	for (int j=0;j<g->childtimers.GetCount();j++)
	{
		TTTTimer* nextTimer=g->childtimers.GetAt(g->childtimers.FindIndex(j));
		if (nextTimer->m_treeitem==NULL) nextTimer->m_treeitem = pTree->InsertItem(nextTimer->m_description,1,1,g->m_treeitem,TVI_SORT);
		else {
			int pic=1;
			if (!nextTimer->m_isRunning) pic=3;
			pTree->SetItem(nextTimer->m_treeitem, TVIF_STATE|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_TEXT, nextTimer->m_description,pic,pic,0,TVIS_BOLD,NULL);
		};
		pTree->Expand(g->m_treeitem, TVE_EXPAND);
	};

	for (int k=0;k<g->childtodos.GetCount();k++)
	{
		TTTTodo* nextTodo=g->childtodos.GetAt(g->childtodos.FindIndex(k));
		if (nextTodo->m_treeitem==NULL) nextTodo->m_treeitem = pTree->InsertItem(nextTodo->m_description,2,2,g->m_treeitem,TVI_SORT);
		else {
			int pic=2;
			if (nextTodo->m_isCompleted) pic=4;
			pTree->SetItem(nextTodo->m_treeitem, TVIF_STATE|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_TEXT, nextTodo->m_description,pic,pic,0,TVIS_BOLD,NULL);
		};
		pTree->Expand(g->m_treeitem, TVE_EXPAND);
	};

	pTree->Expand(pTree->GetRootItem(), TVE_EXPAND);

}

void CTeazersTimeTrackerDlg::OnBnClickedAddGroup()
{
	CTreeCtrl* pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE1);
	ASSERT(pTree != NULL);

	HTREEITEM sel=pTree->GetSelectedItem();
	ASSERT(sel != NULL);

	//suche ermittelte selection per HTREEITEM Id im Gruppenbaum
	TTTGroup* tgtGroup=getParentGroupByTreeId(sel,&rootNode,pTree);

	CString desc;

	CTextEntryDlg dlgTextEntry;
	dlgTextEntry.Show(this, _T("Gruppenname?"), _T("Bitte Gruppenname festlegen"), _T("Neue Gruppe"));
	desc = dlgTextEntry.GetText();

	// fge neue Gruppe als Unterpunkt der ermittelten Gruppe hinzu
	tgtGroup->addGroup(desc);

	updateTree();

	pTree->SetItem(sel,TVIF_STATE,NULL,0,0,TVIS_BOLD,TVIS_BOLD,0);
	pTree->SelectItem(sel);

}

TTTGroup* CTeazersTimeTrackerDlg::getParentGroupByTreeId(HTREEITEM treeid, TTTGroup* g, CTreeCtrl* pTree) 
{
	//Ist diese Gruppe das gesuchte Objekt? Dann gib es zurck!
	if (g->m_treeitem==treeid) return g;

	// Wenn nicht, durchsuche die kindstimer
	for (int j=0;j<g->childtimers.GetCount();j++)
	{
		TTTTimer* nextTimer=g->childtimers.GetAt(g->childtimers.FindIndex(j));
		// Wenn der Timer das gesuchte Objekt ist, gib die vatergruppe zurck.
		if (nextTimer->m_treeitem==treeid) return g;
	};

	// Wenn nicht, durchsuche die kindstodos
	for (int j=0;j<g->childtodos.GetCount();j++)
	{
		TTTTodo* nextTodo=g->childtodos.GetAt(g->childtodos.FindIndex(j));
		// Wenn der Timer das gesuchte Objekt ist, gib die vatergruppe zurck.
		if (nextTodo->m_treeitem==treeid) return g;
	};

	// Wenn nicht, durchsuche die kindgruppen.
	for (int i=0;i<g->childgroups.GetCount();i++)
	{
		TTTGroup* returnedgroup=NULL;
		TTTGroup* nextGroup=g->childgroups.GetAt(g->childgroups.FindIndex(i));
		returnedgroup=getParentGroupByTreeId(treeid,nextGroup,pTree);
		if (returnedgroup!=NULL) return returnedgroup;
	};

	return NULL;
};

TTTTimer* CTeazersTimeTrackerDlg::getTimerByTreeId(HTREEITEM treeid, TTTGroup* g, CTreeCtrl* pTree) 
{
	// Durchsuche die kindstimer
	for (int j=0;j<g->childtimers.GetCount();j++)
	{
		TTTTimer* nextTimer=g->childtimers.GetAt(g->childtimers.FindIndex(j));
		// Wenn der Timer das gesuchte Objekt ist, gib die vatergruppe zurck.
		if (nextTimer->m_treeitem==treeid) return nextTimer;
	};

	// Wenn nicht, durchsuche die kindgruppen.
	for (int i=0;i<g->childgroups.GetCount();i++)
	{
		TTTTimer* returnedtimer=NULL;
		TTTGroup* nextGroup=g->childgroups.GetAt(g->childgroups.FindIndex(i));
		returnedtimer=getTimerByTreeId(treeid,nextGroup,pTree);
		if (returnedtimer!=NULL) return returnedtimer;
	};

	return NULL;
};

TTTTodo* CTeazersTimeTrackerDlg::getTodoByTreeId(HTREEITEM treeid, TTTGroup* g, CTreeCtrl* pTree) 
{
	// Durchsuche die kindstodos
	for (int j=0;j<g->childtodos.GetCount();j++)
	{
		TTTTodo* nextTodo=g->childtodos.GetAt(g->childtodos.FindIndex(j));
		// Wenn das Todo das gesuchte Objekt ist, gib es zurck.
		if (nextTodo->m_treeitem==treeid) return nextTodo;
	};

	// Wenn nicht, durchsuche die kindgruppen.
	for (int i=0;i<g->childgroups.GetCount();i++)
	{
		TTTTodo* returnedtodo=NULL;
		TTTGroup* nextGroup=g->childgroups.GetAt(g->childgroups.FindIndex(i));
		returnedtodo=getTodoByTreeId(treeid,nextGroup,pTree);
		if (returnedtodo!=NULL) return returnedtodo;
	};

	return NULL;
};

CTeazersTimeTrackerDlg::Type CTeazersTimeTrackerDlg::getTypeByTreeId(HTREEITEM treeid, TTTGroup* g, CTreeCtrl* pTree)
{
	//Ist diese Gruppe das gesuchte Objekt? Dann gib es zurck!
	if (g->m_treeitem==treeid) 
	{
		if (g->m_parent==NULL) return ROOT;
		else return GROUP;
	};

	// Durchsuche die kindstimer
	for (int j=0;j<g->childtimers.GetCount();j++)
	{
		TTTTimer* nextTimer=g->childtimers.GetAt(g->childtimers.FindIndex(j));
		if (nextTimer->m_treeitem==treeid) return TIMER;
	};

	// Durchsuche die kindstimer
	for (int j=0;j<g->childtodos.GetCount();j++)
	{
		TTTTodo* nextTodo=g->childtodos.GetAt(g->childtodos.FindIndex(j));
		if (nextTodo->m_treeitem==treeid) return TODO;
	};

	// Wenn nicht, durchsuche die kindgruppen.
	for (int i=0;i<g->childgroups.GetCount();i++)
	{
		Type returnedtype=NONE;
		TTTGroup* nextGroup=g->childgroups.GetAt(g->childgroups.FindIndex(i));
		returnedtype=getTypeByTreeId(treeid,nextGroup,pTree);
		if (returnedtype!=NONE) return returnedtype;
	};

	return NONE;
};

void CTeazersTimeTrackerDlg::OnOK( ) {
	return;
};

void CTeazersTimeTrackerDlg::OnCancel( ) {
	saveTree();
	CDialogEx::OnCancel();
	return;
};


void CTeazersTimeTrackerDlg::OnBnClickedAddTodo()
{
	CTreeCtrl* pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE1);
	ASSERT(pTree != NULL);

	HTREEITEM sel=pTree->GetSelectedItem();
	ASSERT(sel != NULL);

	//suche ermittelte selection per HTREEITEM Id im Gruppenbaum
	TTTGroup* tgtGroup=getParentGroupByTreeId(sel,&rootNode,pTree);
	ASSERT(tgtGroup);

	CString desc;

	CTextEntryDlg dlgTextEntry;
	dlgTextEntry.Show(this, _T("ToDo Beschreibung?"), _T("Bitte ToDo Punkt beschreiben:"), _T("Neues ToDo"));
	desc = dlgTextEntry.GetText();

	// fge neue Gruppe als Unterpunkt der ermittelten Gruppe hinzu
	tgtGroup->addTodo(desc);

	updateTree();

	pTree->SetItem(sel,TVIF_STATE,NULL,0,0,TVIS_BOLD,TVIS_BOLD,0);
	pTree->SelectItem(sel);


};

void CTeazersTimeTrackerDlg::OnBnClickedApply()
{
	CTreeCtrl* pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE1);
	ASSERT(pTree != NULL);

	HTREEITEM sel=pTree->GetSelectedItem();
	ASSERT(sel != NULL);

	Type retType=getTypeByTreeId(sel,&rootNode,pTree);

	TTTTimer* momTimer=NULL;
	TTTTodo* momTodo=NULL;
	TTTGroup* momGroup=NULL;
	CString pause;
	m_tabview.m_tabtimer->m_pausenzeit.GetWindowText(pause);
	CStringA charstr(pause);
	const char* str = (const char *) charstr;

	switch (retType) 
	{
	case TIMER:
			momTimer=getTimerByTreeId(sel,&rootNode,pTree);
			m_tabview.m_tabtimer->m_description.GetWindowText(momTimer->m_description);
			m_tabview.m_tabtimer->m_notes.GetWindowText(momTimer->m_notes);
			m_tabview.m_tabtimer->getStartDateTime(momTimer->m_starttime);
			m_tabview.m_tabtimer->getEndDateTime(momTimer->m_stoptime);
			m_tabview.m_tabtimer->m_pausenzeit.GetWindowText(pause);
			momTimer->m_pausenzeit=atoi(str);
			m_tabview.m_tabtimer->m_length.SetWindowText(momTimer->getLengthStr());
			break;
	case TODO:
			momTodo=getTodoByTreeId(sel,&rootNode,pTree);
			m_tabview.m_tabtodo->m_description.GetWindowText(momTodo->m_description);
			if (m_tabview.m_tabtodo->m_checked.GetCheck()==BST_CHECKED) momTodo->m_isCompleted=TRUE;
			else momTodo->m_isCompleted=FALSE;
			m_tabview.m_tabtodo->m_notes.GetWindowText(momTodo->m_notes);
			break;
	case GROUP:
			momGroup=getParentGroupByTreeId(sel,&rootNode,pTree);
			m_tabview.m_tabgroup->m_description.GetWindowText(momGroup->m_description);
			m_tabview.m_tabgroup->m_notes.GetWindowText(momGroup->m_notes);
	};

	updateTree();

	pTree->SetItem(sel,TVIF_STATE,NULL,0,0,TVIS_BOLD,TVIS_BOLD,0);
	pTree->SelectItem(sel);

}

void CTeazersTimeTrackerDlg::saveTree() 
{
	CFile saveFile;
	saveFile.Open(_T(".\\trackeddata.TTT"), CFile::modeCreate|CFile::modeWrite);
	CArchive archive(&saveFile, CArchive::store);

	CString id(_T("TTT4242!!!"));

	archive << id;

	saveGroup(&rootNode,NULL,archive);
	// Code zum Speichern muss hier kommen

	archive.Close();
	saveFile.Close();
}

void CTeazersTimeTrackerDlg::loadTree() 
{
	CFile loadFile;
	if (!loadFile.Open(_T(".\\trackeddata.TTT"), CFile::modeRead)) 
	{
		AfxMessageBox(_T("FYI: Datenspeicher nicht vorhanden, lege leere Datei an."),MB_OK|MB_ICONINFORMATION);
		return;
	};
	CArchive archive(&loadFile, CArchive::load);

	clearRoot();

	// Code zum Laden muss hier kommen

	CString id;

	archive >> id;

	if (id==_T("TTT4242!!!")) {
		loadGroup(&rootNode,NULL,archive);
	} else {
		AfxMessageBox(_T("FYI: Datenspeicher liegt in veralteter oder korrupter Version vor. Ladevorgang abgebrochen. Programm wird beendet um die Daten zu schtzen."),MB_OK|MB_ICONERROR);
		archive.Close();
		loadFile.Close();
		exit(42);
	};
	
	archive.Close();
	loadFile.Close();

	updateTree();
	// Ja, zweimal. Denn erst beim Update der HTREEITEMS werden die Icons auf den korrekten status gesetzt.
	// Ich weiss. Das geht besser. Aber optimieren kann man immer noch und die tatschliche Laufzeit bleibt
	// an dieser Stelle konstant. O(n) oder O(2n), pah. Lineare Laufzeiten sind toll.
	updateTree();
}

void CTeazersTimeTrackerDlg::saveGroup(TTTGroup* g,TTTGroup* p,CArchive &a)
{
		int numGroups,numTodos,numTimers=0;

		numTodos=g->childtodos.GetSize();
		numTimers=g->childtimers.GetSize();
		numGroups=g->childgroups.GetSize();
	
		a << g->m_description << g->m_notes;

		a << numTodos << numTimers << numGroups;

		for (int i=0;i<numTodos;i++) 
		{
			TTTTodo* nextTodo=g->childtodos.GetAt(g->childtodos.FindIndex(i));
			ASSERT(nextTodo);
			a << nextTodo->m_description << nextTodo->m_isCompleted << nextTodo->m_notes;
		};

		for (int i=0;i<numTimers;i++) 
		{
			TTTTimer* nextTimer=g->childtimers.GetAt(g->childtimers.FindIndex(i));
			ASSERT(nextTimer);
			a << nextTimer->m_description << nextTimer->m_isRunning << nextTimer->m_notes << nextTimer->m_starttime<< nextTimer->m_stoptime<< nextTimer->m_pausenzeit;
		};

		for (int i=0;i<numGroups;i++) 
		{
			TTTGroup* nextGroup=g->childgroups.GetAt(g->childgroups.FindIndex(i));
			ASSERT(nextGroup);
			saveGroup(nextGroup,g,a);
		};


}

void CTeazersTimeTrackerDlg::loadGroup(TTTGroup* g,TTTGroup* p,CArchive &a)
{
		int numGroups,numTodos,numTimers=0;

		a >> g->m_description >> g->m_notes;

		a >> numTodos >> numTimers >> numGroups;

		for (int i=0;i<numTodos;i++) 
		{
			TTTTodo* newTodo = new TTTTodo(g);
			a >> newTodo->m_description >> newTodo->m_isCompleted >> newTodo->m_notes;
			g->childtodos.AddHead(newTodo);
		};

		for (int i=0;i<numTimers;i++) 
		{
			TTTTimer* newTimer = new TTTTimer(g);
			a >> newTimer->m_description >> newTimer->m_isRunning >> newTimer->m_notes >> newTimer->m_starttime >> newTimer->m_stoptime >> newTimer->m_pausenzeit;
			g->childtimers.AddHead(newTimer);
		};

		for (int i=0;i<numGroups;i++) 
		{
			TTTGroup* newGroup = new TTTGroup();
			newGroup->m_parent=g;
			g->childgroups.AddHead(newGroup);
			loadGroup(newGroup,g,a);
		};

}

void CTeazersTimeTrackerDlg::stopTimer(TTTTimer* t)
{
	t->m_stoptime=COleDateTime::GetCurrentTime();
	t->m_isRunning=FALSE;
}

void CTeazersTimeTrackerDlg::stopGroupTimers(TTTGroup* g)
{
	int numTimers,numGroups;

	numTimers=g->childtimers.GetCount();
	numGroups=g->childgroups.GetCount();
	
	for (int i=0;i<numTimers;i++) stopTimer(g->childtimers.GetAt(g->childtimers.FindIndex(i)));
	for (int i=0;i<numGroups;i++) stopGroupTimers(g->childgroups.GetAt(g->childgroups.FindIndex(i)));
}

void CTeazersTimeTrackerDlg::stopAllTimers()
{
	stopGroupTimers(&rootNode);
}




void CTeazersTimeTrackerDlg::OnBnClickedBStop()
{
	CTreeCtrl* pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE1);
	ASSERT(pTree != NULL);

	HTREEITEM sel=pTree->GetSelectedItem();
	ASSERT(sel != NULL);

	Type retType=getTypeByTreeId(sel,&rootNode,pTree);

	TTTTimer* momTimer=NULL;

	switch (retType) 
	{
	case TIMER:
			momTimer=getTimerByTreeId(sel,&rootNode,pTree);
			stopTimer(momTimer);
			m_tabview.m_tabtimer->setEndDateTime(momTimer->m_stoptime);
			m_tabview.m_tabtimer->setEndDisabled(FALSE);
			m_tabview.m_tabtimer->m_length.SetWindowText(momTimer->getLengthStr());
			break;
	};

	updateTree();

	pTree->SetItem(sel,TVIF_STATE,NULL,0,0,TVIS_BOLD,TVIS_BOLD,0);
	pTree->SelectItem(sel);


}

void CTeazersTimeTrackerDlg::OnBnClickedBGstop()
{
	CTreeCtrl* pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE1);
	ASSERT(pTree != NULL);

	HTREEITEM sel=pTree->GetSelectedItem();
	ASSERT(sel != NULL);

	Type retType=getTypeByTreeId(sel,&rootNode,pTree);

	TTTGroup* momGroup=NULL;

	switch (retType) 
	{
	case GROUP:
			momGroup=getParentGroupByTreeId(sel,&rootNode,pTree);
			stopGroupTimers(momGroup);
			break;
	};

	updateTree();

	pTree->SetItem(sel,TVIF_STATE,NULL,0,0,TVIS_BOLD,TVIS_BOLD,0);
	pTree->SelectItem(sel);
}


void CTeazersTimeTrackerDlg::OnBnClickedBAstop()
{
	stopAllTimers();

	CTreeCtrl* pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE1);
	ASSERT(pTree != NULL);

	HTREEITEM sel=pTree->GetSelectedItem();
	ASSERT(sel != NULL);

	Type retType=getTypeByTreeId(sel,&rootNode,pTree);

	TTTTimer* momTimer=NULL;

	switch (retType) 
	{
	case TIMER:
			momTimer=getTimerByTreeId(sel,&rootNode,pTree);
			m_tabview.m_tabtimer->setEndDateTime(momTimer->m_stoptime);
			m_tabview.m_tabtimer->setEndDisabled(FALSE);
			m_tabview.m_tabtimer->m_length.SetWindowText(momTimer->getLengthStr());
			break;
	};

	updateTree();

	pTree->SetItem(sel,TVIF_STATE,NULL,0,0,TVIS_BOLD,TVIS_BOLD,0);
	pTree->SelectItem(sel);
}

void CTeazersTimeTrackerDlg::removeNode() 
{
	CTreeCtrl* pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE1);
	ASSERT(pTree != NULL);

	HTREEITEM sel=pTree->GetSelectedItem();
	ASSERT(sel != NULL);

	Type retType=getTypeByTreeId(sel,&rootNode,pTree);

	TTTGroup* momGroup=NULL;
	TTTTimer* momTimer=NULL;
	TTTTodo* momTodo=NULL;

	switch (retType) 
	{
	case GROUP:
		if (AfxMessageBox(_T("Soll diese komplette Gruppe und somit auch all Ihre Timer,ToDos und Untergruppen wirklich vollstndig gelscht werden?"), MB_YESNO|MB_ICONWARNING)!=IDYES) return;
		momGroup=getParentGroupByTreeId(sel,&rootNode,pTree);
		pTree->DeleteItem(momGroup->m_treeitem);
		delete momGroup;
		break;
	case TIMER:
		if (AfxMessageBox(_T("Soll dieser Timer wirklich gelscht werden?"), MB_YESNO|MB_ICONWARNING)!=IDYES) return;
		momTimer=getTimerByTreeId(sel,&rootNode,pTree);
		pTree->DeleteItem(momTimer->m_treeitem);
		delete momTimer;
		break;
	case TODO:
		if (AfxMessageBox(_T("Soll diese Aufgabe wirklich gelscht werden?"), MB_YESNO|MB_ICONWARNING)!=IDYES) return;
		momTodo=getTodoByTreeId(sel,&rootNode,pTree);
		pTree->DeleteItem(momTodo->m_treeitem);
		delete momTodo;
		break;
	};

	updateTree();

	pTree->SetItem(rootNode.m_treeitem,TVIF_STATE,NULL,0,0,TVIS_BOLD,TVIS_BOLD,0);
	pTree->SelectItem(rootNode.m_treeitem);

}
	
void CTeazersTimeTrackerDlg::clearRoot() 
{
	while (rootNode.childtimers.GetCount()>0) delete rootNode.childtimers.GetHead();
	while (rootNode.childtodos.GetCount()>0) delete rootNode.childtodos.GetHead();
	while (rootNode.childgroups.GetCount()>0) delete rootNode.childgroups.GetHead();

	CTreeCtrl* pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE1);
	ASSERT(pTree != NULL);

	pTree->DeleteAllItems();

	TVINSERTSTRUCT tvInsert;
	tvInsert.hParent = NULL;
	tvInsert.hInsertAfter = NULL;
	tvInsert.item.mask = TVIF_TEXT;
	tvInsert.item.state = TVIS_EXPANDED;
	tvInsert.item.stateMask = TVIS_EXPANDED;
	tvInsert.item.pszText = _T("*");

	rootNode.m_treeitem = pTree->InsertItem(&tvInsert);
	pTree->Expand(rootNode.m_treeitem,TVE_EXPAND);

	pTree->SetItem(rootNode.m_treeitem,TVIF_STATE,NULL,0,0,TVIS_BOLD,TVIS_BOLD,0);
	pTree->SelectItem(rootNode.m_treeitem);
}


// Ist nicht in Benutzung. MSDN ist fehlerbehaftet, Beispielcode funktioniert nicht und 
// Doku ist lckenhaft. Feature ist auf Eis gelegt.
int CALLBACK 
CTeazersTimeTrackerDlg::MyCompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
   CTreeCtrl* pTree = (CTreeCtrl*) lParamSort;
   HTREEITEM obj1 = ((HTREEITEM) lParam1);
   HTREEITEM obj2 = ((HTREEITEM) lParam2);

   Type tobj1 = this->getTypeByTreeId(obj1,&rootNode,pTree);
   Type tobj2 = this->getTypeByTreeId(obj2,&rootNode,pTree);

   if (tobj1!=tobj2) {

	   // Gruppen stehen immer vorne.
		if (tobj1==GROUP) return -1;
		if (tobj2==GROUP) return +1;

		// Rest wird optimiert nach Kline/McCluskey (oder wie die Typen hiessen, vllt. auch nach Roger deMoore? :D) und siehe da...
		if (tobj1==TODO) return +1;
		if (tobj1==TIMER) return -1;
		return -1;
   }
   else
   {
	   TTTGroup *g_rtobj1,*g_rtobj2;
	   TTTTimer *ti_rtobj1,*ti_rtobj2;
	   TTTTodo *to_rtobj1,*to_rtobj2;

	   switch (tobj1) 
	   {
	   case GROUP:
		   g_rtobj1 = this->getParentGroupByTreeId(obj1,&rootNode,pTree);
		   g_rtobj2 = this->getParentGroupByTreeId(obj2,&rootNode,pTree);
		   g_rtobj1->m_description.CompareNoCase(g_rtobj2->m_description);
		   break;
	   case TIMER:
		   ti_rtobj1 = this->getTimerByTreeId(obj1,&rootNode,pTree);
		   ti_rtobj2 = this->getTimerByTreeId(obj2,&rootNode,pTree);
		   ti_rtobj1->m_description.CompareNoCase(ti_rtobj2->m_description);
		   break;
	   case TODO:
		   to_rtobj1 = this->getTodoByTreeId(obj1,&rootNode,pTree);
		   to_rtobj2 = this->getTodoByTreeId(obj2,&rootNode,pTree);
		   to_rtobj1->m_description.CompareNoCase(to_rtobj2->m_description);
		   break;
	   };
   };

   return 0;
}


void CTeazersTimeTrackerDlg::OnBnClickedBtnDelnode()
{
	this->removeNode();
}


void CTeazersTimeTrackerDlg::OnBnClickedBtnExport()
{
	CTreeCtrl* pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE1);
	ASSERT(pTree != NULL);

	HTREEITEM sel=pTree->GetSelectedItem();
	ASSERT(sel != NULL);

	//suche ermittelte selection per HTREEITEM Id im Gruppenbaum
	TTTGroup* tgtGroup=getParentGroupByTreeId(sel,&rootNode,pTree);

	TTTExportDlg expDlg(this);

	int result=expDlg.DoModal();

	if (result!=IDOK) return;

	CFileDialog FileDlg(FALSE, _T(".csv"), NULL, 0, _T("Excel Files (*.csv)|*.csv|All Files (*.*)|*.*||"));

	if( FileDlg.DoModal() == IDOK )
	{

		CFile f;

		// check for existing filename
		WIN32_FIND_DATA findData;
		ZeroMemory(&findData, sizeof(findData));
		HANDLE hFind = FindFirstFile( FileDlg.GetPathName(), &findData );
		if ( hFind != INVALID_HANDLE_VALUE ) {
			if (AfxMessageBox(_T("Datei ist bereits vorhanden. Soll sie berschrieben werden?"), MB_YESNO|MB_ICONWARNING)!=IDYES) return;
		}
		FindClose( hFind );
		hFind = NULL;
		
		if( f.Open(FileDlg.GetPathName(), CFile::modeCreate|CFile::modeWrite) == FALSE ) {
			AfxMessageBox(_T("Exportdatei kann nicht geffnet werden: ")+FileDlg.GetPathName(), MB_OK|MB_ICONERROR);
			return;
		};

		CString csvOfTimers=_T("Start,Ende,Pausenzeit,Arbeitszeit,Beschreibung,\r\n");
		getChildTimersCSV(tgtGroup,&csvOfTimers);
		CStringA charstr(csvOfTimers);
		const char* str = (const char *) charstr;
		f.Write((const void*)str,strlen(str));
		f.Close();
		AfxMessageBox(_T("Export erfolgreich abgeschlossen."), MB_OK|MB_ICONINFORMATION);

	}
	else
		return;

}

void CTeazersTimeTrackerDlg::getChildTimersCSV(TTTGroup* g,CString* str) {

	for (int i=0;i<g->childgroups.GetCount();i++)
	{
		TTTGroup* nextGroup=g->childgroups.GetAt(g->childgroups.FindIndex(i));
		getChildTimersCSV(nextGroup,str);
	};

	for (int i=0;i<g->childtimers.GetCount();i++)
	{
		TTTTimer* nextTimer=g->childtimers.GetAt(g->childtimers.FindIndex(i));
		COleDateTimeSpan ts=nextTimer->getLength();
		CString neueZeile=_T("");
		CString corrDescr = nextTimer->m_description;
		corrDescr.Replace(_T("\""),_T("\"\""));
		neueZeile.Format(
			_T("%04d-%02d-%02dT%02d:%02d:%02d,%04d-%02d-%02dT%02d:%02d:%02d,%d min,%02d:%02d:%02d,\"%s\",\r\n"),
			nextTimer->m_starttime.GetYear(),
			nextTimer->m_starttime.GetMonth(),
			nextTimer->m_starttime.GetDay(),
			nextTimer->m_starttime.GetHour(),
			nextTimer->m_starttime.GetMinute(),
			nextTimer->m_starttime.GetSecond(),
			nextTimer->m_stoptime.GetYear(),
			nextTimer->m_stoptime.GetMonth(),
			nextTimer->m_stoptime.GetDay(),
			nextTimer->m_stoptime.GetHour(),
			nextTimer->m_stoptime.GetMinute(),
			nextTimer->m_stoptime.GetSecond(),
			nextTimer->m_pausenzeit,
			((ts.GetDays()*24)+ts.GetHours()),
			ts.GetMinutes(),
			ts.GetSeconds(),
			corrDescr
			);
	
		BOOL addLine=TRUE;

		if (!m_filternostart)
			if (m_filterstart>nextTimer->m_starttime)
				addLine=FALSE;
		if (!m_filternoend)
			if (m_filterend>nextTimer->m_stoptime)
				addLine=FALSE;

		if (addLine) (*str)+=neueZeile;
	};

};

void CTeazersTimeTrackerDlg::getChildTimersCount(TTTGroup* g, int* count) {

	for (int i=0;i<g->childgroups.GetCount();i++)
	{
		TTTGroup* nextGroup=g->childgroups.GetAt(g->childgroups.FindIndex(i));
		getChildTimersCount(nextGroup,count);
	};
}; 


void CTeazersTimeTrackerDlg::OnBnClickedBtnExpnode2()
{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
}
