
// TeazersTimeTrackerDlg.h: Headerdatei
//

#pragma once

#include "TTTGroup.h"
#include "MyTabCtrl2.h"
#include "afxwin.h"

// CTeazersTimeTrackerDlg-Dialogfeld
class CTeazersTimeTrackerDlg : public CDialogEx
{
// Konstruktion
public:
	CTeazersTimeTrackerDlg(CWnd* pParent = NULL);	// Standardkonstruktor

// Dialogfelddaten
	enum { IDD = IDD_TEAZERSTIMETRACKER_DIALOG };

	enum Type { TIMER, GROUP, ROOT, TODO, NONE };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung

//	CMyTabCtrl2 m_tabctrl;

// Implementierung
protected:
	HICON m_hIcon;

	// Generierte Funktionen fr die Meldungstabellen
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

public:
	afx_msg void OnTvnSelchangedTree1(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedAddTimer();
	TTTGroup rootNode;
	CImageList iList;
	void updateTree();
	void drawGroup(TTTGroup* g, CTreeCtrl* pTree);
	TTTGroup* getParentGroupByTreeId(HTREEITEM treeid, TTTGroup* g, CTreeCtrl* pTree);
	TTTTimer* getTimerByTreeId(HTREEITEM treeid, TTTGroup* g, CTreeCtrl* pTree);
	TTTTodo* getTodoByTreeId(HTREEITEM treeid, TTTGroup* g, CTreeCtrl* pTree);
	Type getTypeByTreeId(HTREEITEM treeid, TTTGroup* g, CTreeCtrl* pTree);
	void getChildTimersCount(TTTGroup*,int*);
	void getChildTimersCSV(TTTGroup*,CString*);
	afx_msg void OnBnClickedAddGroup();
	CMyTabCtrl2 m_tabview;
	virtual void OnOK( );
	virtual void OnCancel( );

	void saveTree();
	void loadTree();

	void saveGroup(TTTGroup* g,TTTGroup* p,CArchive &a);
	void loadGroup(TTTGroup* g,TTTGroup* p,CArchive &a);

	void stopTimer(TTTTimer* t);
	void stopGroupTimers(TTTGroup* g);
	void stopAllTimers();

	void removeNode();

	void clearRoot();

	int CALLBACK MyCompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);

	afx_msg void OnBnClickedAddTodo();
	afx_msg void OnBnClickedApply();
	afx_msg void OnBnClickedBStop();
	afx_msg void OnBnClickedBGstop();
	afx_msg void OnBnClickedBAstop();
	CButton m_btn_stop;
	CButton m_btn_gstop;
	CButton m_btn_astop;
	afx_msg void OnBnClickedBtnDelnode();
	CButton m_btn_removenode;
	afx_msg void OnBnClickedBtnExport();

	COleDateTime m_filterstart;
	COleDateTime m_filterend;
	BOOL m_filternostart;
	BOOL m_filternoend;
	CButton m_btn_expnode;
	afx_msg void OnBnClickedBtnExpnode2();
};
